/*  Festalon - NSF Player
 *  Copyright (C) 2002 Ben Parnell
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

typedef struct {
	   void (*Fill)(int Count);
	   void (*NeoFill)(int32 *Wave, int Count);
	   void (*HiFill)(void);
	   void (*HiSync)(int32 ts);
	   void (*RChange)(void);
	   void (*Kill)(void);
	   int32 volmul;
} EXPSOUND;

extern EXPSOUND GameExpSound;

void SetSoundVariables(void);
void PowerSound(void);
void ResetSound(void);

extern uint8 fcnt;
extern int32 fhcnt;
extern int32 fhinc;

int FlushEmulateSound(void);
extern uint32 Wave[];
extern int32 WaveFinal[];
extern int32 WaveHi[];

void SetNESSoundMap(void);
void RDoPCM(void);
void FrameSoundUpdate(void);
void DoPCM(void);

